//=============================================================================
// SPAssualtRifle.
//=============================================================================
class SPAssualtRifle expands AssaultWeapon;

#exec MESH IMPORT MESH=psgfirst ANIVFILE=MODELS\psgfirst_a.3d DATAFILE=MODELS\psgfirst_d.3d X=0 Y=0 Z=0 MLOD=0
#exec MESH ORIGIN MESH=psgfirst X=0 Y=0 Z=0 YAW=-64

#exec MESH SEQUENCE MESH=psgfirst SEQ=All        		STARTFRAME=0 NUMFRAMES=177
#exec MESH SEQUENCE MESH=psgfirst SEQ=AIMTOHIP   		STARTFRAME=0 NUMFRAMES=5
#exec MESH SEQUENCE MESH=psgfirst SEQ=BRINGDOWN  		STARTFRAME=5 NUMFRAMES=10
#exec MESH SEQUENCE MESH=psgfirst SEQ=BRINGUP    		STARTFRAME=15 NUMFRAMES=10
#exec MESH SEQUENCE MESH=psgfirst SEQ=FIRE       		STARTFRAME=25 NUMFRAMES=5
#exec MESH SEQUENCE MESH=psgfirst SEQ=HIPTOAIM   		STARTFRAME=30 NUMFRAMES=5
#exec MESH SEQUENCE MESH=psgfirst SEQ=STILL      		STARTFRAME=145 NUMFRAMES=1
#exec MESH SEQUENCE MESH=psgfirst SEQ=STILLAIM   		STARTFRAME=146 NUMFRAMES=1
#exec MESH SEQUENCE MESH=psgfirst SEQ=ZIDLE	   		STARTFRAME=147 NUMFRAMES=5

#exec TEXTURE IMPORT NAME=HandArmSkin FILE=MODELS\HandArm.PCX GROUP=Skins // Skin
#exec TEXTURE IMPORT NAME=PSGSkin FILE=MODELS\PsgFirst1.PCX GROUP=Skins // Gun

#exec MESHMAP NEW   MESHMAP=psgfirst MESH=psgfirst
#exec MESHMAP SCALE MESHMAP=psgfirst X=0.1 Y=0.1 Z=0.2

#exec MESHMAP SETTEXTURE MESHMAP=psgfirst NUM=1 TEXTURE=PSGSkin
#exec MESHMAP SETTEXTURE MESHMAP=psgfirst NUM=2 TEXTURE=HandArmSkin


// Third Person.

#exec MESH IMPORT MESH=PsgThird ANIVFILE=MODELS\PsgThird_a.3d DATAFILE=MODELS\PsgThird_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=PsgThird X=0 Y=0 Z=0

#exec MESH SEQUENCE MESH=PsgThird SEQ=All                      STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=PsgThird SEQ=Still                    STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW   MESHMAP=PsgThird MESH=PsgThird
#exec MESHMAP SCALE MESHMAP=PsgThird X=0.1 Y=0.1 Z=0.2

#exec MESHMAP SETTEXTURE MESHMAP=PsgThird NUM=1 TEXTURE=PSGSkin

// Pickup.

#exec MESH IMPORT MESH=PsgPickup ANIVFILE=MODELS\PsgThird_a.3d DATAFILE=MODELS\PsgThird_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=PsgPickup X=0 Y=0 Z=0 ROLL=64

#exec MESH SEQUENCE MESH=PsgPickup SEQ=All                      STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=PsgPickup SEQ=Still                    STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW   MESHMAP=PsgPickup MESH=PsgPickup
#exec MESHMAP SCALE MESHMAP=PsgPickup X=0.1 Y=0.1 Z=0.2

#exec MESHMAP SETTEXTURE MESHMAP=PsgPickup NUM=1 TEXTURE=PSGSkin

// Sounds.

#exec AUDIO IMPORT FILE=

#exec TEXTURE IMPORT NAME=Muzzy3 FILE=MODELS\Muzzy3.PCX GROUP=Skins
#exec TEXTURE IMPORT NAME=MuzzleFlash2 FILE=TEXTURES\NewMuz2.PCX GROUP="Rifle" MIPS=OFF LODSET=2
#exec TEXTURE IMPORT NAME=SniperScope FILE=TEXTURES\rifleret.PCX GROUP="Icons" MIPS=OFF FLAGS=2 LODSET=2


#exec MESH IMPORT MESH=muzzsr3 ANIVFILE=MODELS\muzzle2_a.3d DATAFILE=MODELS\Muzzle2_d.3d X=0 Y=0 Z=0
#exec MESH LODPARAMS MESH=muzzsr3 MINVERTS=8 STRENGTH=0.7 ZDISP=800.0
#exec MESH ORIGIN MESH=muzzsr3 X=0 Y=980 Z=-75 YAW=64
#exec MESH SEQUENCE MESH=muzzsr3 SEQ=All                      STARTFRAME=0 NUMFRAMES=3
#exec MESH SEQUENCE MESH=muzzsr3 SEQ=Shoot                   STARTFRAME=0 NUMFRAMES=3
#exec MESHMAP NEW   MESHMAP=muzzsr3 MESH=muzzsr3
#exec MESHMAP SCALE MESHMAP=muzzsr3 X=0.04 Y=0.1 Z=0.08


// Animation.
struct Animation
{
	var()	name	AnimSeq;
	var()	float	AnimRate;
	var()	sound	AsscSound;
};
var(Animation)	Animation	animBringUp;
var(Animation)	Animation	animBringDown;
var(Animation)	Animation	animHipToAim;
var(Animation)	Animation	animAimToHip;
var(Animation)	Animation	animFire;
var(Animation)	Animation	animStill;
var(Animation)	Animation	animStillAim;
var(Animation)	Animation	animIdle;
var(Animation)	float		MaxIdleTime;
var int NumFire;
var name FireAnims[5];
var vector OwnerLocation;
var float StillTime, StillStart;
var bool bZoom;
var	int	maxzoom;


function PostBeginPlay()
{
	Super.PostBeginPlay();
}

simulated function PostRender( canvas Canvas )
{
	local PlayerPawn P;
	local float Scale;
	local float Xlength;
	local float range;
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
    local actor Other;
	local float radpitch;


	Super.PostRender(Canvas);
	P = PlayerPawn(Owner);
	if ( (P != None) && (P.DesiredFOV != P.DefaultFOV) )
	{
		bOwnsCrossHair = true;

		if ( Level.bHighDetailMode )
			Canvas.Style = ERenderStyle.STY_Translucent;
		else
			Canvas.Style = ERenderStyle.STY_Normal;

		// Square
		Canvas.SetPos( 3*Canvas.ClipX/7, 3*Canvas.ClipY/7 );
		Canvas.DrawTile( Texture'SPSniperScope', Canvas.ClipX/7, Canvas.ClipY/7, 0, 0, 256, 193 );

		// Top Line
		Canvas.SetPos( 200*Canvas.ClipX/401, Canvas.ClipY/229*(90-P.DesiredFOV)+0.6*Canvas.ClipY/28 );
		Canvas.DrawTile( Texture'SPSniperScope', Canvas.ClipX/401, Canvas.ClipY/28, 0, 20, 3, 10 );

		// Bottom Line
		Canvas.SetPos( 200*Canvas.ClipX/401, 15.35*Canvas.ClipY/28 + Canvas.ClipY/229*P.DesiredFOV );
		Canvas.DrawTile( Texture'SPSniperScope', Canvas.ClipX/401, Canvas.ClipY/28, 0, 20, 3, 10 );

		// Left Line
		Canvas.SetPos( Canvas.ClipX/229*(90-P.DesiredFOV)+0.6*Canvas.ClipX/28, 200*Canvas.ClipY/401 );
		Canvas.DrawTile( Texture'SPSniperScope', Canvas.ClipX/28, Canvas.ClipY/401, 10, 0, 10, 3 );

		// Right Line
		Canvas.SetPos( 15.35*Canvas.ClipX/28 + Canvas.ClipX/229*P.DesiredFOV, 200*Canvas.ClipY/401 );
		Canvas.DrawTile( Texture'SPSniperScope', Canvas.ClipX/28, Canvas.ClipY/401, 10, 0, 10, 3 );

		// Dot
	//	Canvas.SetPos( (9*Canvas.ClipX/19) + (Canvas.ClipX/P.DesiredFOV/6), (9*Canvas.ClipY/19) + (Canvas.ClipY/P.DesiredFOV/6) );
	//	Canvas.DrawTile( Texture'SPSniperScope',
	//		(Canvas.ClipX/19) - (Canvas.ClipX/P.DesiredFOV/3), (Canvas.ClipY/19) - (Canvas.ClipY/P.DesiredFOV/3), 0, 202, 53, 53 );
		Canvas.SetPos( 199.5*Canvas.ClipX/401, 199.5*Canvas.ClipY/401 );
		Canvas.DrawTile( Texture'SPSniperScope', 2*Canvas.ClipX/401, 2*Canvas.ClipY/401, 0, 202, 53, 53 );

		// Top Gradient
		Canvas.SetPos( 200*Canvas.ClipX/401, 4*Canvas.ClipY/9 );
		Canvas.DrawTile( Texture'SPSniperScope', Canvas.ClipX/401, Canvas.ClipY/1360*(90-P.DesiredFOV), 129, 197, 3, 54 );

		// Left Gradient
		Canvas.SetPos( 4*Canvas.ClipX/9, 200*Canvas.ClipY/401 );
		Canvas.DrawTile( Texture'SPSniperScope', Canvas.ClipX/1360*(90-P.DesiredFOV), Canvas.ClipY/401, 69, 200, 54, 3 );

		//Bottom Gradient
		Canvas.SetPos( 200*Canvas.ClipX/401, 5*Canvas.ClipY/9 - Canvas.ClipY/1360*(90-P.DesiredFOV) );
		Canvas.DrawTile( Texture'SPSniperScope', Canvas.ClipX/401, Canvas.ClipY/1360*(90-P.DesiredFOV), 144, 199, 3, 54 );

		//Right Gradient
		Canvas.SetPos( 5*Canvas.ClipX/9 - Canvas.ClipX/1360*(90-P.DesiredFOV), 200*Canvas.ClipY/401 );
		Canvas.DrawTile( Texture'SPSniperScope', Canvas.ClipX/1360*(90-P.DesiredFOV), Canvas.ClipY/401, 163, 199, 54, 3 );

	// Calc range
        XLength=255.0;
		GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
		if ((Pawn(Owner).ViewRotation.Pitch >= 0) && (Pawn(Owner).ViewRotation.Pitch <= 18000)) radpitch = float(Pawn(Owner).ViewRotation.Pitch) / float(182) * (Pi/float(180));
		else radpitch = float(Pawn(Owner).ViewRotation.Pitch - 65535) / float(182) * (Pi/float(180));
	    StartTrace = Owner.Location + Pawn(Owner).EyeHeight*Z*cos(radpitch);
    	AdjustedAim = pawn(owner).AdjustAim(1000000, StartTrace, 2.75*AimError, False, False);
		EndTrace = StartTrace +(10000 * vector(AdjustedAim));
		Other = Pawn(Owner).TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);
		range = Vsize(StartTrace-HitLocation)/48-0.25;

	// Magnification Display
		Canvas.DrawColor.R = 0;
		Canvas.DrawColor.G = 255;
		Canvas.DrawColor.B = 0;
		Scale = P.DefaultFOV/P.DesiredFOV;
		Canvas.SetPos( 202*Canvas.ClipX/401, 4*Canvas.ClipY/7 + Canvas.ClipY/401 );
		Canvas.DrawText( "["$int(range)$"."$int(10*range-10*int(range))$" m]    Sniper's Paradise    ["$int(Scale)$"."$int(10 * Scale - 10 * int(Scale))$"x]" );

	
	}
	else
		bOwnsCrossHair = false;
}


function float RateSelf( out int bUseAltMode )
{
	if ( AmmoType.AmmoAmount <=0 )
		return -2;

	bUseAltMode = 0;
	return AIRating;

}

function AltFire( float Value )
{
	GoToState('AltFiring');

}

///////////////////////////////////////////////////////
state NormalFire
{
	function Fire(float F)
	{
	}

	function AltFire(float F)
	{
	}

Begin:
	FinishAnim();
	Finish();
}

function Timer()
{
	local actor targ;
	local float bestAim, bestDist;
	local vector FireDir;

	bestAim = 0.95;
	if ( Pawn(Owner) == None )
	{
		GotoState('');
		return;
	}
	FireDir = vector(Pawn(Owner).ViewRotation);
	targ = Pawn(Owner).PickTarget(bestAim, bestDist, FireDir, Owner.Location);
	if ( Pawn(targ) != None )
	{
		SetTimer(1 + 4 * FRand(), false);
		bPointing = true;
		Pawn(targ).WarnTarget(Pawn(Owner), 200, FireDir);
	}
	else
	{
		SetTimer(0.4 + 1.6 * FRand(), false);
		bPointing = false;
	}
}

function PlayAltFiring()
{
	if ( PlayerPawn(Owner) != None )
		PlayerPawn(Owner).shakeview(ShakeTime, ShakeMag, ShakeVert);
	Owner.PlaySound(FireSound, SLOT_None,Pawn(Owner).SoundDampening*3.0.0,,,0.9 + 0.2 * FRand());
	PlayAnim('Fire', 2.0,0.05);
}

function PlayFiring()
{
	Owner.PlaySound(FireSound, SLOT_None, Pawn(Owner).SoundDampening*3.0.0);
	PlayAnim('Fire', 0.7,0.05);
}

function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
/*	local Shellcase s;

	s = Spawn(class'ShellCase',, '', Owner.Location + CalcDrawOffset() + 30 * X + (2.8 * FireOffset.Y+5.0) * Y - Z * 1);
	if ( s != None )
	{
		s.DrawScale = 2.0;
		s.Eject(((FRand()*0.3+0.4)*X + (FRand()*0.2+0.2)*Y + (FRand()*0.3+1.0) * Z)*160);
	}           */
	if (Other == Level)
		Spawn(class'HeavyWallHitEffect',,, HitLocation+HitNormal, Rotator(HitNormal));
	else if ( (Other != self) && (Other != Owner) && (Other != None) )
	{
		if ( Other.bIsPawn )
			Other.PlaySound(Sound 'ChunkHit',, 4.0,,100);
		if ( Other.bIsPawn && (HitLocation.Z - Other.Location.Z > 0.62 * Other.CollisionHeight)
			&& (instigator.IsA('PlayerPawn') || (instigator.skill > 1))
			&& ((Owner.Physics != PHYS_Falling && Owner.Physics != PHYS_Swimming && Pawn(Owner).bDuck != 0)
			   || Owner.Velocity == 0 * Owner.Velocity) )
			Other.TakeDamage(100, Pawn(Owner), HitLocation, 35000 * X, AltDamageType);
		else
			Other.TakeDamage(45,  Pawn(Owner), HitLocation, 30000.0*X, MyDamageType);
		if ( !Other.bIsPawn && !Other.IsA('Carcass') )
			spawn(class'SpriteSmokePuff',,,HitLocation+HitNormal*9);
	}
}

/*
function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local Shellcase s;

	if ( PlayerPawn(Owner) != None )
	{
		PlayerPawn(Owner).ClientInstantFlash( -0.4, vect(650, 450, 190));
		if ( PlayerPawn(Owner).DesiredFOV == PlayerPawn(Owner).DefaultFOV )
			bMuzzleFlash++;
	}

	s = Spawn(class'ShellCase',Pawn(Owner), '', Owner.Location + CalcDrawOffset() + 30 * X + (2.8 * FireOffset.Y+5.0) * Y - Z * 1);
	if ( s != None )
	{
		s.DrawScale = 2.0;
		s.Eject(((FRand()*0.3+0.4)*X + (FRand()*0.2+0.2)*Y + (FRand()*0.3+1.0) * Z)*160);
	}
	if (Other == Level)
		Spawn(class'HeavyWallHitEffect',,, HitLocation+HitNormal*9, Rotator(HitNormal));
	else if ( (Other != self) && (Other != Owner) && (Other != None) )
	{
		if ( Other.IsA('Pawn') && (HitLocation.Z - Other.Location.Z > 0.62 * Other.CollisionHeight)
			&& (instigator.IsA('PlayerPawn') || (instigator.skill > 1))
			&& (!Other.IsA('ScriptedPawn') || !ScriptedPawn(Other).bIsBoss) )
			Other.TakeDamage(100, Pawn(Owner), HitLocation, 35000 * X, 'decapitated');
		else
			Other.TakeDamage(45,  Pawn(Owner), HitLocation, 30000.0*X, 'shot');
		if ( !Other.IsA('Pawn') && !Other.IsA('Carcass') )
			spawn(class'SpriteSmokePuff',,,HitLocation+HitNormal*9);
	}
}
*/
function Finish()
{
	//bMuzzleFlash = 0;
	if ( ((Pawn(Owner).bFire!=0) || (Pawn(Owner).bAltFire!=0)) && (FRand() < 0.6) )
		Timer();
	Super.Finish();
}

state Idle
{

	function AltFire( float Value )
	{
		GoToState('AltFiring');
	}

	function Fire( float Value )
	{
		if (AmmoType.UseAmmo(1))
		{
			GotoState('NormalFire');
			if ( PlayerPawn(Owner) != None )
				PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
			bPointing=True;
			TraceFire(0.0);
			PlayFiring();
			CheckVisibility();
		}
	}


	function BeginState()
	{
		if (Pawn(Owner).bFire!=0) Fire(0.0);
		bPointing = false;
		SetTimer(0.4 + 1.6 * FRand(), false);
		Super.BeginState();
	}

	function EndState()
	{
		SetTimer(0.0, false);
		Super.EndState();
	}

Begin:
	bPointing=False;
	if ( (AmmoType != None) && (AmmoType.AmmoAmount<=0) )
		Pawn(Owner).SwitchToBestWeapon();  //Goto Weapon that has Ammo
	if ( Pawn(Owner).bFire!=0 ) Fire(0.0);
	Disable('AnimEnd');
	PlayIdleAnim();
}

///////////////////////////////////////////////////////

state AltFiring
{

function Timer()
{
	if (Pawn(Owner).bAltFire == 0)
	{
		if (PlayerPawn(Owner) != None)
			PlayerPawn(Owner).StopZoom();
		SetTimer(0.0,False);
		GoToState('Idle');
	}
}

Begin:
	if ( Owner.IsA('PlayerPawn') )
	{
		PlayerPawn(Owner).ToggleZoom();
		SetTimer(0.075,True);
	}
	else
	{
		Pawn(Owner).bFire = 1;
		Pawn(Owner).bAltFire = 0;
		Global.Fire(0);
	}
}
/*
state AltFiring
{
	simulated function Tick(float DeltaTime)
	{
		if ( Pawn(Owner).bAltFire == 0 )
		{
			bZoom = false;
			SetTimer(0.0,False);
			GoToState('Idle');
		}
		else if ( bZoom )
		{
			if ( PlayerPawn(Owner).DesiredFOV > 3 )
			{
				PlayerPawn(Owner).DesiredFOV -= PlayerPawn(Owner).DesiredFOV*DeltaTime*4.0;
			}

			if ( PlayerPawn(Owner).DesiredFOV <=3 )
			{
				PlayerPawn(Owner).DesiredFOV = 3;
				bZoom = false;
				SetTimer(0.0,False);
				GoToState('Idle');
			}
		}
	}


//simulated function BeginState()
Begin:
//	{
		if ( Owner.IsA('PlayerPawn') )
		{
			if ( PlayerPawn(Owner).DesiredFOV == PlayerPawn(Owner).DefaultFOV )
			{
				bZoom = true;
				SetTimer(0.2,True);
			}
			else if ( bZoom == false )
			{
				PlayerPawn(Owner).DesiredFOV = PlayerPawn(Owner).DefaultFOV;
				Pawn(Owner).bAltFire = 0;
			}
		}
		else
		{
			Pawn(Owner).bFire = 1;
			Pawn(Owner).bAltFire = 0;
			Global.Fire(0);
		}
	}
//}
*/
///////////////////////////////////////////////////////////
function PlayIdleAnim()
{
	PlayAnim('Still',1.0, 0.05);
}

function TraceFire( float Accuracy )
{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
	local actor Other;
	local Pawn PawnOwner;

	if ( MaxTargetRange < 4096 ) MaxTargetRange = 2000;

	PawnOwner = Pawn(Owner);

	Owner.MakeNoise(PawnOwner.SoundDampening);
	GetAxes(PawnOwner.ViewRotation,X,Y,Z);
	StartTrace = Owner.Location + PawnOwner.Eyeheight * Z; 
	AdjustedAim = PawnOwner.AdjustAim(1000000, StartTrace, 2*AimError, False, False);	
	X = vector(AdjustedAim);
	EndTrace = StartTrace + MaxTargetRange * X; 
	Other = PawnOwner.TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);
	ProcessTraceHit(Other, HitLocation, HitNormal, X,Y,Z);
}

defaultproperties
{
				animFire=(AnimSeq="Fire",AnimRate=0.660000,AsscSound=Sound'AssualtSnds.Snipe.SilentFire')
				MaxTargetRange=20000.000000
				AmmoName=Class'KOK.SniperAmmo'
				PickupAmmoCount=150
				bInstantHit=True
				bAltInstantHit=True
				bRapidFire=True
				FiringSpeed=0.200000
				FireOffset=(X=3.200000,Y=-3.200000,Z=-2.850000)
				MyDamageType="SHOT"
				AltDamageType="Decapitated"
				shakemag=0.000000
				shaketime=0.000100
				shakevert=0.000000
				AIRating=0.240000
				RefireRate=0.050000
				AltRefireRate=0.100000
				FireSound=Sound'AssualtSnds.Snipe.SilentFire'
				AltFireSound=Sound'UnrealShare.AutoMag.SHOT'
				SelectSound=Sound'UnrealShare.ASMD.Vapour'
				DeathMessage="%k put a bullet through %o's head with the Sniper Assualt Rifle."
				MuzzleScale=1.000000
				FlashY=0.110000
				FlashO=0.014000
				FlashC=0.031000
				FlashS=256
				MFTexture=Texture'KOK.Skins.MuzzleFlash2'
				AutoSwitchPriority=9
				InventoryGroup=9
				bAmbientGlow=False
				PickupMessage="You picked up a Long Range Sniper Assault Rifle"
				ItemName="Swat Assualt Rifle"
				PlayerViewOffset=(X=-5.200000,Y=0.666667,Z=-2.850000)
				PlayerViewMesh=Mesh'KOK.psgfirst'
				PlayerViewScale=0.750000
				BobDamping=0.000000
				PickupViewMesh=LodMesh'KOK.PsgPickup'
				ThirdPersonMesh=LodMesh'KOK.PsgThird'
				ThirdPersonScale=0.750000
				MuzzleFlashStyle=STY_Translucent
				MuzzleFlashScale=0.100000
				MuzzleFlashTexture=Texture'KOK.Skins.Muzzy3'
				PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
				Icon=Texture'KOK.Icons.I_223'
				Mesh=LodMesh'KOK.PsgPickup'
				AmbientGlow=0
				bNoSmooth=False
				CollisionRadius=28.000000
				CollisionHeight=8.000000
}
